<template>
  <div class="survey-answer-template pb-5 border-bottom border-3">
    <div class="row">
      <div class="col">
        <h1 class="ps-2 pt-3 text-decoration-underline fw-bold text-danger">Survey {{ idProp + 1 }}</h1>
      </div>
    </div>

    <quiz-survey-type :type-game="typeGame" @change-type-answer="changeTypeAnswer" :id-prop="idProp"></quiz-survey-type>

    <quiz-survey-content
      :id-prop="idProp"
      @update-content="updateContent"
      :value-content="surveyContent"
    ></quiz-survey-content>

    <quiz-survey-answer
      :idProp="idProp"
      :type-answer="typeAnswer"
      :answer-value="answerValue"
      @update-answer-value="updateAnswerValue"
    ></quiz-survey-answer>

    <quiz-survey-correct
      :idProp="idProp"
      :type-answer="typeAnswer"
      :correct-answer="correctAnswer"
      @update-correct-answer="updateCorrectAnswer"
    >
    </quiz-survey-correct>
  </div>
</template>

<script>
import QuizSurveyType from "./QuizSurveyType.vue";
import QuizSurveyContent from "./QuizSurveyContent.vue";
import QuizSurveyAnswer from "./QuizSurveyAnswer.vue";
import QuizSurveyCorrect from "./QuizSurveyCorrect.vue";

export default {
  props: {
    idProp: Number
  },
  components: {
    QuizSurveyType,
    QuizSurveyContent,
    QuizSurveyAnswer,
    QuizSurveyCorrect
  },
  data() {
    return {
      typeGame: "survey",
      surveyContent: "",
      typeAnswer: "survey-1",
      correctAnswer: "1",
      answerValue: [
        { key: "1", content: "" },
        { key: "2", content: "" },
        { key: "3", content: "" },
        { key: "4", content: "" }
      ],
      isSubmitted: false
    };
  },
  methods: {
    changeTypeAnswer(data) {
      this.typeAnswer = data;
    },
    updateContent(data) {
      this.surveyContent = data;
    },
    updateCorrectAnswer(data) {
      this.correctAnswer = data;
    },
    updateAnswerValue(data) {
      this.answerValue = this.answerValue.map((item) => {
        if (item.key !== data.key) return item;

        item.content = data.content;
        return item;
      });
    }
  }
};
</script>

<style scoped></style>
